#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include <led.h>

volatile uint16_t count;
register unsigned char part asm("r4");

ISR(TIM0_COMPA_vect)
{
    if (part == 9)
    {
        part=0;
		count++;
    }

    part++;
}

int main(void) {
	// GPIO setup
 	DDRB |= (SCLK | RCLK | DIO);
    // Timer setup
	TCCR0A=(1<<WGM01);			// set CTC mode
    TCCR0B=(1<<CS02)|(1<<CS00); // prescaller 1/1024
    OCR0A=117;         			// freq 10Hz
    TIMSK0=(1<<OCIE0A); 		// enable interrupt
	// init variables
	count=0; // start nmber
	part=1;
	// let's go...
	sei();
 	for (;;)
	{
		show_led(count);
		_delay_ms(5);
 	}
	return 0;
}
