#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include <led.h>

#define PULSE PB1
#define LATCH PB0

volatile uint16_t count;
volatile uint16_t value;

ISR(PCINT0_vect) {
	if (PINB & (1<<LATCH)) {
	    GIMSK &=~(1<<INT0);
		count=value;
	} else {
	    GIMSK|=(1<<INT0);
		value=0;
	}
}

ISR(INT0_vect) {
    value++;
}

int main(void) {
    CLKPR =(1<<CLKPCE);
    CLKPR =0; // set 9.6 MHz CPU freq

	// GPIO setup
 	DDRB |= (SCLK | RCLK | DIO); // LATCH & PULSE as INPUT
    // external interrupt
    MCUCR|=(1<<ISC01)|(1<<ISC00); // IRQ on rising edge
    GIMSK|=(1<<PCIE);
    PCMSK|=(1<<PCINT0);
 	// init variables
	count=0; // start nmber
	value=0;
	// let's go...
	sei();
 	for (;;)
	{
		show_led(count);
		_delay_ms(5);
 	}
	return 0;
}
