#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include <led.h>

#define PULSE PB1
#define LATCH PB0

volatile uint16_t count;
volatile uint8_t  bf[2];
register uint8_t  idx 	asm("r4");
register uint8_t  value asm("r5");


ISR(PCINT0_vect) {
	if (PINB & (1<<LATCH)) {
	    GIMSK &=~(1<<INT0);

		bf[idx]=value;
	    idx=(idx) ? 0 : 1;

	    if ((bf[0] >=32) && (bf[1]<32))
    	    count=((bf[0]-32)<<5)+bf[1];
    	else if ((bf[1] >=32) && (bf[0]<32))
        	count=((bf[1]-32)<<5)+bf[0];

	} else {
	    GIMSK|=(1<<INT0);
		value=0;
	}
}

ISR(INT0_vect) {
    value++;
}

int main(void) {
    CLKPR =(1<<CLKPCE);
    CLKPR =0; // set 9.6 MHz CPU freq

	// GPIO setup
 	DDRB |= (SCLK | RCLK | DIO); // LATCH & PULSE as INPUT
    // external interrupt
    MCUCR|=(1<<ISC01)|(1<<ISC00); // IRQ on rising edge
    GIMSK|=(1<<PCIE);
    PCMSK|=(1<<PCINT0);
 	// init variables
	count=0; // start nmber
	value=0;
	idx=0;
	// let's go...
	sei();
 	for (;;)
	{
		show_led(count);
		_delay_ms(5);
 	}
	return 0;
}
