#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include <led.h>
/*
    PB1 - Rx UART
*/

register uint8_t  k        asm("r4");
register uint8_t  rx_data  asm("r5");
register uint8_t  value    asm("r6");

ISR(INT0_vect){
	// START
	GIMSK &= ~(1<<INT0); // disable
	// cleaning  variables
	k=0; rx_data=0;
	// timer enable
	TCNT0=0;
	TCCR0A=(1<<WGM01);  // set CTC mode
	TCCR0B=(1<<CS01);   // prescaller 1/8
	OCR0A=114;          // rate 9600
	TIMSK0=(1<<OCIE0A); // enable interrupt
}

ISR(TIM0_COMPA_vect){
	if ((PINB & (1<<PB1))) rx_data |=0x80;

	if (k < 8) {
		rx_data >>=1;
	} else {
		value=rx_data;
	    TCCR0B=0; OCR0A=0; TIMSK0=0;
		TIFR0 |= (1 << OCF0A); // Очищаем флаг прерывания (важно!)
		GIFR |= (1 << INTF0);
		GIMSK |= (1<<INT0); // enable interrupt
	}

	k++;
}
int main(void) {
    // set CPUfreq = 9.6 MHz
    CLKPR =(1<<CLKPCE);
    CLKPR =0; // set 9.6 MHz CPU freq
    // disable ADC
    PRR = (1<<PRADC);
	// ext. irq init
    MCUCR=(1<<ISC01); // falling edge for ext. iqr & power_down sleep mode && sleep mode
    GIMSK=(1<<INT0);
 	// GPIO setup
 	DDRB |= (SCLK | RCLK | DIO);
	value=0;
	// let's go...
	sei();
 	for (;;)
	{
		show_led(value);
		_delay_ms(5);
 	}
	return 0;
}
