#include <avr/io.h>
#include <led.h>

uint8_t reg=0;

static void spi_transmit(uint8_t data) {
    uint8_t i;

    for (i=0; i<8; i++)
    {
        PORTB=(data & 0x80) ? PORTB | DIO : PORTB & ~DIO;

        data=(data<<1);

        PORTB |= SCLK;
        PORTB &= ~SCLK;
    }
}

static void to_led(uint8_t value, uint8_t reg) {
static uint8_t digit[10] = {
      0b11000000, // 0
      0b11111001, // 1
      0b10100100, // 2
      0b10110000, // 3
      0b10011001, // 4
      0b10010010, // 5
      0b10000010, // 6
      0b11111000, // 7
      0b10000000, // 8
      0b10010000, // 9
};
    PORTB &= ~RCLK;
    spi_transmit(digit[value%10]);
    spi_transmit(1<<reg);
    PORTB |= RCLK;

}

void show_led(uint16_t num) {
        switch (reg) {
        case 0:
            to_led((uint8_t)(num%10),0);
            break;
        case 1:
            if (num>=10)
                to_led((uint8_t)((num%100)/10),1);
            break;
        case 2:
            if (num>=100)
                to_led((uint8_t)(num/100),2);
            break;
        }

        reg = (reg ==  2) ? 0 : reg+1;
}

